diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index be34c4c97..7147476be 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -19,6 +19,9 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 	private float[] heata;
 	private int ticks = 0;
 
+	private int width;
+	private int height;
+
 	public DynamicTextureWaterFlow(@NotNull IconCoordinate targetTexture) {
 		super(targetTexture);
 	}
@@ -27,40 +30,42 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 	public void postInit() {
 		initTexture();
 
-        this.current = new float[this.targetTexture.getArea()];
-        this.next = new float[this.targetTexture.getArea()];
-        this.heat = new float[this.targetTexture.getArea()];
-        this.heata = new float[this.targetTexture.getArea()];
+		this.width = this.targetTexture.width/2;
+		this.height = this.targetTexture.height/2;
+        this.current = new float[this.width * this.height];
+        this.next = new float[this.width * this.height];
+        this.heat = new float[this.width * this.height];
+        this.heata = new float[this.width * this.height];
 	}
 
 	@Override
 	public void update() {
 		this.ticks++;
 
-		for (int x = 0; x < this.targetTexture.width; ++x) {
-			for (int y = 0; y < this.targetTexture.height; ++y) {
+		for (int x = 0; x < this.width; ++x) {
+			for (int y = 0; y < this.height; ++y) {
 				float pow = 0.0F;
 
 				for (int k = y - 2; k <= y; ++k) {
-					int xi = floorMod(x, this.targetTexture.width);
-					int yi = floorMod(k, this.targetTexture.height);
-					pow += this.current[xi + yi * this.targetTexture.width];
+					int xi = floorMod(x, this.width);
+					int yi = floorMod(k, this.height);
+					pow += this.current[xi + yi * this.width];
 				}
 
-				this.next[x + y * this.targetTexture.width] = pow / 3.2F + this.heat[x + y * this.targetTexture.width] * 0.8F;
+				this.next[x + y * this.width] = pow / 3.2F + this.heat[x + y * this.width] * 0.8F;
 			}
 		}
 
-		for (int x = 0; x < this.targetTexture.width; ++x) {
-			for (int y = 0; y < this.targetTexture.height; ++y) {
-				this.heat[x + y * this.targetTexture.width] += this.heata[x + y * this.targetTexture.width] * 0.05F;
-				if (this.heat[x + y * this.targetTexture.width] < 0.0F) {
-					this.heat[x + y * this.targetTexture.width] = 0.0F;
+		for (int x = 0; x < this.width; ++x) {
+			for (int y = 0; y < this.height; ++y) {
+				this.heat[x + y * this.width] += this.heata[x + y * this.width] * 0.05F;
+				if (this.heat[x + y * this.width] < 0.0F) {
+					this.heat[x + y * this.width] = 0.0F;
 				}
 
-				this.heata[x + y * this.targetTexture.width] -= 0.3F;
+				this.heata[x + y * this.width] -= 0.3F;
 				if (Math.random() < 0.2D) {
-					this.heata[x + y * this.targetTexture.width] = 0.5F;
+					this.heata[x + y * this.width] = 0.5F;
 				}
 			}
 		}
@@ -70,40 +75,45 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 		this.current = tmp;
 
         byte[] imageData = getImageData(this.layerColor);
-		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
-			float pow = this.current[floorMod(i - this.ticks * this.targetTexture.width, this.targetTexture.getArea())];
-			pow = MathHelper.clamp(pow, 0.0f, 1.0f);
-			float pp = pow * pow;
-
-			int r = (int) (32.0F + pp * 32.0F);
-			int g = (int) (50.0F + pp * 64.0F);
-			int b = 255;
-			int a = (int) (146.0F + pp * 50.0F);
-
-			if (this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
-				a = (int) (225.0F + pp * 50.0F);
-
-				if (!GameSettings.BIOME_WATER.value) {
-					final float br = 0.3F;
-					r = (int) (255.0F * br);
-					g = (int) ((50.0F + pp * 64.0F) * br);
-					b = (int) ((32.0F + pp * 32.0F) * br);
+		for (int x = 0; x < this.targetTexture.width; x++) {
+			for (int y = 0; y < this.targetTexture.height; y++) {
+				int i = y * this.targetTexture.width + x;
+				int i2 = (y % this.height) * this.width + (x % this.width);
+
+				float pow = this.current[floorMod(i2 - this.ticks * this.width, this.current.length)];
+				pow = MathHelper.clamp(pow, 0.0f, 1.0f);
+				float pp = pow * pow;
+
+				int r = (int) (32.0F + pp * 32.0F);
+				int g = (int) (50.0F + pp * 64.0F);
+				int b = 255;
+				int a = (int) (146.0F + pp * 50.0F);
+
+				if (this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
+					a = (int) (225.0F + pp * 50.0F);
+
+					if (!GameSettings.BIOME_WATER.value) {
+						final float br = 0.3F;
+						r = (int) (255.0F * br);
+						g = (int) ((50.0F + pp * 64.0F) * br);
+						b = (int) ((32.0F + pp * 32.0F) * br);
+					}
 				}
-			}
 
-			r = MathHelper.clamp(r, 0, 255);
-			g = MathHelper.clamp(g, 0, 255);
-			b = MathHelper.clamp(b, 0, 255);
-			a = MathHelper.clamp(a, 0, 255);
+				r = MathHelper.clamp(r, 0, 255);
+				g = MathHelper.clamp(g, 0, 255);
+				b = MathHelper.clamp(b, 0, 255);
+				a = MathHelper.clamp(a, 0, 255);
 
-			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO))) {
-				r = g = b = (r + g + b) / 3;
-			}
+				if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO))) {
+					r = g = b = (r + g + b) / 3;
+				}
 
-			imageData[i * 4] = (byte) r;
-			imageData[i * 4 + 1] = (byte) g;
-			imageData[i * 4 + 2] = (byte) b;
-			imageData[i * 4 + 3] = (byte) a;
+				imageData[i * 4] = (byte) r;
+				imageData[i * 4 + 1] = (byte) g;
+				imageData[i * 4 + 2] = (byte) b;
+				imageData[i * 4 + 3] = (byte) a;
+			}
 		}
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 2ed1db0aa..2062744b0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -51,7 +51,7 @@ public class ItemModelBlock extends ItemModelStandard {
         GLRenderer.setShader(Shaders.ITEM);
         DisplayPos displayPos = getDisplayPos(displayPosId);
         var model = GLRenderer.modelM4f();
-        model.translate(displayPos.tx, displayPos.ty, displayPos.tz);
+        model.translate(leftHanded ? -displayPos.tx : displayPos.tx, displayPos.ty, displayPos.tz);
         model.rotateX(Math.toRadians(displayPos.rx));
         model.rotateY(Math.toRadians(leftHanded ? -displayPos.ry : displayPos.ry));
         model.rotateZ(Math.toRadians(leftHanded ? -displayPos.rz : displayPos.rz));
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 7a975a202..0e30bd73c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -76,7 +76,7 @@ public class ItemModelStandard extends ItemModel{
         final DisplayPos displayPos = getDisplayPos(displayPosId);
 
         var model = GLRenderer.modelM4f();
-        model.translate(displayPos.tx, displayPos.ty, displayPos.tz);
+        model.translate(leftHanded ? -displayPos.tx : displayPos.tx, displayPos.ty, displayPos.tz);
         model.rotateX(org.joml.Math.toRadians(displayPos.rx));
         model.rotateY(org.joml.Math.toRadians(leftHanded ? -displayPos.ry : displayPos.ry));
         model.rotateZ(org.joml.Math.toRadians(leftHanded ? -displayPos.rz : displayPos.rz));
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
index 0f080c642..fb34a43f7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
@@ -6,7 +6,7 @@ public class ParticleAsh extends Particle {
     public ParticleAsh(World world, double x, double y, double z, double xa, double ya, double za) {
         super(world, x, y, z, xa, ya, za);
         this.xd = xa + (Math.random() * 2D - 1.0D) * 0.05F;
-        this.yd = ya - Math.random() * 2D * 0.2F;
+        this.yd = ya - (0.02D + Math.random() * 0.05D);
         this.zd = za + (Math.random() * 2D - 1.0D) * 0.05F;
         this.rCol = this.gCol = this.bCol = 0.2F + random.nextFloat() * 0.3F;
         this.size = random.nextFloat() * random.nextFloat() * 6F + 1.0F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index 1eda33cc3..554208712 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -17,18 +17,14 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry> {
     private static ParticleDispatcher INSTANCE = new ParticleDispatcher();
-    private static final ParticleEntry BLANK = new ParticleEntry() {
-        @Override
-        public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-            return null;
-        }
-    };
+    private static final ParticleEntry BLANK = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
 
     public static ParticleDispatcher getInstance() {
         return INSTANCE;
@@ -46,114 +42,24 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
     private ParticleDispatcher() {
         INSTANCE = this;
         Minecraft mc = Minecraft.getMinecraft();
-        addDispatch("bubble", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD), true);
-            }
-        });
-        addDispatch("bubbleboiling", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleBubbleBoiling(world, x, y, z, motionX, motionY, motionZ, true);
-            }
-        });
-        addDispatch("smoke", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 1.0f, data);
-            }
-        });
-        addDispatch("note", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleNote(world, x, y, z, motionX, motionY, motionZ, data);
-            }
-        });
-        addDispatch("portal", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticlePortal(world, x, y, z, motionX, motionY, motionZ, data);
-            }
-        });
-        addDispatch("explode", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleExplode(world, x, y, z, motionX, motionY, motionZ);
-            }
-        });
-        addDispatch("flame", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.ORANGE);
-            }
-        });
-        addDispatch("blueflame", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.BLUE);
-            }
-        });
-        addDispatch("soulflame", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.SOUL);
-            }
-        });
-        addDispatch("lava", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleLava(world, x, y, z);
-            }
-        });
-        addDispatch("footstep", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFootstep(mc.textureManager, world, x, y, z);
-            }
-        });
-        addDispatch("splash", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleSplash(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD));
-            }
-        });
-        addDispatch("largesmoke", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 2.5f, data);
-            }
-        });
-        addDispatch("puffrgb", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data);
-            }
-        });
-        addDispatch("reddust", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleRedstoneDust(world, x, y, z, data);
-            }
-        });
-        addDispatch("item", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]);
-            }
-        });
-        addDispatch("block", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init(new TilePos(x, y, z));
-            }
-        });
-        addDispatch("snowshovel", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ);
-            }
-        });
+        addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD), true));
+        addDispatch("bubbleboiling", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBubbleBoiling(world, x, y, z, motionX, motionY, motionZ, true));
+        addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 1.0f, data));
+        addDispatch("note", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleNote(world, x, y, z, motionX, motionY, motionZ, data));
+        addDispatch("portal", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePortal(world, x, y, z, motionX, motionY, motionZ, data));
+        addDispatch("explode", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleExplode(world, x, y, z, motionX, motionY, motionZ));
+        addDispatch("flame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.ORANGE));
+        addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.BLUE));
+        addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFlame(world, x, y, z, motionX, motionY, motionZ, ParticleFlame.Type.SOUL));
+        addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleLava(world, x, y, z));
+        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFootstep(mc.textureManager, world, x, y, z));
+        addDispatch("splash", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSplash(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD)));
+        addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSmoke(world, x, y, z, motionX, motionY, motionZ, 2.5f, data));
+        addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
+        addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
+        addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init(new TilePos(x, y, z)));
+        addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionZ));
         addDispatch("heart", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
@@ -176,30 +82,10 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
                 return GameSettings.SLIME_PARTICLES.value;
             }
         });
-        addDispatch("fireflyGreen", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.GREEN.getId());
-            }
-        });
-        addDispatch("fireflyBlue", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.BLUE.getId());
-            }
-        });
-        addDispatch("fireflyOrange", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.ORANGE.getId());
-            }
-        });
-        addDispatch("fireflyRed", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.RED.getId());
-            }
-        });
+        addDispatch("fireflyGreen", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.GREEN.getId()));
+        addDispatch("fireflyBlue", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.BLUE.getId()));
+        addDispatch("fireflyOrange", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.ORANGE.getId()));
+        addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFirefly(world, x, y, z, motionX, motionY, motionZ, MobFireflyCluster.FireflyColor.RED.getId()));
         addDispatch("arrowtrail", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
@@ -211,89 +97,53 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
                 return GameSettings.PARTICLES_QUALITY.value != ParticlesQuality.NONE;
             }
         });
-        addDispatch("fallingleaf", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                TilePos tilePos = new TilePos(x, y, z);
-                if (!world.isAirBlock(tilePos)) {
-                    return new ParticleLeaf(world, x, y, z, motionX, motionY, motionZ).init(tilePos);
-                }
-                return null;
-            }
-        });
-        addDispatch("dripWater", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, new TilePos(x, y, z), 0);
-                return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/fluid/water/flowing"));
-            }
-        });
-        addDispatch("dripLava", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/fluid/lava/flowing")).setFullBright();
-            }
-        });
-        addDispatch("dripAcid", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/fluid/acid/flowing")).setFullBright();
-            }
-        });
-        addDispatch("ashmote", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleAsh(world, x, y, z, 0, 0, 0);
-            }
-        });
-
-        addDispatch("ventsmoke", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleVentSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f, data);
+        addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
+            TilePos tilePos = new TilePos(x, y, z);
+            if (!world.isAirBlock(tilePos)) {
+                return new ParticleLeaf(world, x, y, z, motionX, motionY, motionZ).init(tilePos);
             }
+            return null;
         });
-
-        addDispatch("rubyglassLightning", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                float pitch = 0;
-                float yaw = 0;
-                switch (Direction.fromId(data)) {
-                    case DOWN -> {
-                        pitch = 0.0f;
-                        yaw = 0.0f;
-                    }
-                    case UP -> {
-                        pitch = MathHelper.PI;
-                        yaw = 0.0f;
-                    }
-                    case NORTH -> {
-                        pitch = MathHelper.PI / 2.0f;
-                        yaw = 0.0f;
-                    }
-                    case SOUTH -> {
-                        pitch = -MathHelper.PI / 2.0f;
-                        yaw = 0.0f;
-                    }
-                    case WEST -> {
-                        pitch = MathHelper.PI / 2.0f;
-                        yaw = MathHelper.PI / 2.0f;
-                    }
-                    case EAST -> {
-                        pitch = MathHelper.PI / 2.0f;
-                        yaw = -MathHelper.PI / 2.0f;
-                    }
+        addDispatch("dripWater", (world, x, y, z, motionX, motionY, motionZ, data) -> {
+            int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, new TilePos(x, y, z), 0);
+            return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/fluid/water/flowing"));
+        });
+        addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/fluid/lava/flowing")).setFullBright());
+        addDispatch("dripAcid", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/fluid/acid/flowing")).setFullBright());
+        addDispatch("ashmote", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleAsh(world, x, y, z, motionX, motionY, motionZ));
+        addDispatch("ventsmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleVentSmoke(world, x, y, z, motionX, motionY, motionX, 2.5f, data));
+        addDispatch("rubyglassLightning", (world, x, y, z, motionX, motionY, motionZ, data) -> {
+            float pitch = 0;
+            float yaw = 0;
+            switch (Direction.fromId(data)) {
+                case DOWN -> {
+                    pitch = 0.0f;
+                    yaw = 0.0f;
+                }
+                case UP -> {
+                    pitch = Math.PI_f;
+                    yaw = 0.0f;
+                }
+                case NORTH -> {
+                    pitch = Math.PI_OVER_2_f;
+                    yaw = 0.0f;
+                }
+                case SOUTH -> {
+                    pitch = -Math.PI_OVER_2_f;
+                    yaw = 0.0f;
+                }
+                case WEST -> {
+                    pitch = Math.PI_OVER_2_f;
+                    yaw = Math.PI_OVER_2_f;
+                }
+                case EAST -> {
+                    pitch = Math.PI_OVER_2_f;
+                    yaw = -Math.PI_OVER_2_f;
                 }
-                return new ParticleRubyglassLightning(world, x, y, z, pitch, yaw);
             }
+            return new ParticleRubyglassLightning(world, x, y, z, pitch, yaw);
         });
 
-        addDispatch("acidBoiling", new ParticleEntry() {
-            @Override
-            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleAcidBoiling(world, x, y, z, motionX, motionY, motionZ, true);
-            }
-        });
+        addDispatch("acidBoiling", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleAcidBoiling(world, x, y, z, motionX, motionY, motionZ, true));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java
index 23b8917d5..a788d0b2c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleEntry.java
@@ -5,9 +5,9 @@ import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public abstract class ParticleEntry {
-    public abstract Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
-    public boolean enabled() {
+public interface ParticleEntry {
+    Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data);
+    default boolean enabled() {
         return GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.ALL;
     }
 }
